//----------------------------------------------------------------------//
// NyanFi																//
//  ^XNXbh													//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <mmsystem.h>
#include <System.DateUtils.hpp>
#include "usr_file_ex.h"
#include "usr_wic.h"
#include "usr_exif.h"
#include "usr_excmd.h"
#include "UserFunc.h"
#include "Global.h"
#include "task_thread.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//^XNݒNX
//---------------------------------------------------------------------------
TaskConfig::TaskConfig()
{
	TaskList	= new TStringList();
	UpdDirList	= new TStringList();

	CopyAll    = false;
	CopyMode   = 0;
	SetDstPos  = false;
	KeepTime   = false;
	FilterMode = 0;

	CvImg_f_ext.USET_T(".jpg");
	CvImg_quality	   = 80;
	CvImg_ycrcb 	   = 0;
	CvImg_cmp_mode	   = 0;
	CvImg_scale_mode   = 0;
	CvImg_scale_prm1   = 100;
	CvImg_scale_prm2   = 100;
	CvImg_scale_opt    = 0;
	CvImg_not_use_prvw = false;
	CvImg_grayscale    = false;
	CvImg_mgn_color    = clBlack;

	Bakup_sub_sw   = false;
	Bakup_mirror   = false;
}
//---------------------------------------------------------------------------
TaskConfig::~TaskConfig()
{
	delete TaskList;
	delete UpdDirList;
}

//---------------------------------------------------------------------------
void TaskConfig::Assign(TaskConfig *cp)
{
	TaskList->Assign(cp->TaskList);
	UpdDirList->Assign(cp->UpdDirList);

	CopyAll 		   = cp->CopyAll;
	CopyMode		   = cp->CopyMode;
	SetDstPos		   = cp->SetDstPos;

	CmdStr			   = cp->CmdStr;
	InfStr			   = cp->InfStr;

	CvImg_f_ext 	   = cp->CvImg_f_ext;
	CvImg_quality	   = cp->CvImg_quality;
	CvImg_ycrcb 	   = cp->CvImg_ycrcb;
	CvImg_cmp_mode	   = cp->CvImg_cmp_mode;
	CvImg_scale_mode   = cp->CvImg_scale_mode;
	CvImg_scale_prm1   = cp->CvImg_scale_prm1;
	CvImg_scale_prm2   = cp->CvImg_scale_prm2;
	CvImg_scale_opt    = cp->CvImg_scale_opt;
	CvImg_not_use_prvw = cp->CvImg_not_use_prvw;
	CvImg_grayscale    = cp->CvImg_grayscale;
	CvImg_mgn_color    = cp->CvImg_mgn_color;
}

//---------------------------------------------------------------------------
// ^XNݒ胊Xg (TList p)
//---------------------------------------------------------------------------
__fastcall TaskConfigList::TaskConfigList(): TList()
{
}
//---------------------------------------------------------------------------
__fastcall TaskConfigList::~TaskConfigList()
{
	ClearAll();
}

//---------------------------------------------------------------------------
TaskConfig * __fastcall TaskConfigList::Get(int Index)
{
	return (TaskConfig*)(TList::Get(Index));
}
//---------------------------------------------------------------------------
void __fastcall TaskConfigList::Put(int Index, TaskConfig *Item)
{
	TList::Put(Index, Item);
}

//---------------------------------------------------------------------------
//}[NׂăNA
//---------------------------------------------------------------------------
void __fastcall TaskConfigList::ClearAll()
{
	for (int i=0; i<Count; i++) delete Items[i];
	Clear();
}

//---------------------------------------------------------------------------
int TaskIdCount = 0;

//---------------------------------------------------------------------------
//Xbh̏
//---------------------------------------------------------------------------
__fastcall TTaskThread::TTaskThread(bool CreateSuspended) : TThread(CreateSuspended)
{
	Priority		= tpNormal;
	FreeOnTerminate = true;

	TaskReady  = TaskFinished = false;
	TaskCancel = TaskPause = false;
	TaskIsFast = ReqTaskSlow = false;
	DirDeleted = false;

	PreCount = SubCount = OkCount = SkipCount = RenCount = ErrCount = 0;
	CurTotalSize = 0;
	CurProgress  = -1;

	Config		= new TaskConfig();

	IsSamePath = false;

	Tag = 0;
	ID  = TaskIdCount++;

	LastTransferred.QuadPart = 0;
	SmplSize  = 0;
	LastCount = 0;
	Speed	  = 0;
}

//---------------------------------------------------------------------------
//MoveFileWithProgressACopyFileEx pR[obN֐
//---------------------------------------------------------------------------
DWORD CALLBACK TTaskThread::ProgressRoutine(
	LARGE_INTEGER TotalFileSize,
	LARGE_INTEGER TotalBytesTransferred,
	LARGE_INTEGER StreamSize,
	LARGE_INTEGER StreamBytesTransferred,
	DWORD dwStreamNumber,
	DWORD dwCallbackReason,
	HANDLE hSourceFile,
	HANDLE hDestinationFile,
	LPVOID lpData)
{
	return ((TTaskThread*)lpData)->ProgressCore(TotalFileSize, TotalBytesTransferred);
}
//---------------------------------------------------------------------------
DWORD __fastcall TTaskThread::ProgressCore(LARGE_INTEGER TotalFileSize, LARGE_INTEGER TotalBytesTransferred)
{
	//U~̏
	if (TaskPause) {
		while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);
		TaskIsFast = false;
		return TaskCancel? PROGRESS_CANCEL : PROGRESS_CONTINUE;
	}
	//f
	if (TaskCancel) return PROGRESS_CANCEL;

	//i(0.0`1.0)
	CurProgress  = (TotalFileSize.QuadPart>0)? 1.0*TotalBytesTransferred.QuadPart/TotalFileSize.QuadPart : -1;
	CurTotalSize = TotalFileSize.QuadPart;

	//]xvZ
	SmplSize += (TotalBytesTransferred.QuadPart - LastTransferred.QuadPart);
	LastTransferred = TotalBytesTransferred;
	int cur_cnt  = GetTickCount();
	int smpl_cnt = (cur_cnt - LastCount);
	if (smpl_cnt>1000) {	//***
		LastCount = cur_cnt;
		Speed = SmplSize / smpl_cnt;
		SmplSize = 0;
	}

	//c莞ԂvZ
	RemCount = (Speed>0)? (TotalFileSize.QuadPart-TotalBytesTransferred.QuadPart)/Speed : 0;

	//҂ (TCYt@C̏̂߁AŏƍŌɂ͑҂Ȃ)
	if (CurProgress>0.0 && CurProgress<1.0) {
		if (ReqTaskSlow) {
			ReqTaskSlow = false;
			Sleep(SLOW_INTERVAL);
		}
		else {
			TaskIsFast = (NopDtctTime>0) && ((int)(GetTickCount() - LastOpCount) > NopDtctTime*1000);
			if (TaskIsFast)
				Sleep((Speed>67108)? 0 : MIN_INTERVAL);	//*** 64MB/bȏȂ 0
			else
				Sleep(std::max(IsRemote? RemoteWaitTime : NormalWaitTime, MIN_INTERVAL));
		}
	}

	return PROGRESS_CONTINUE;
}

//---------------------------------------------------------------------------
//OɃbZ[Wǉ
//---------------------------------------------------------------------------
void __fastcall TTaskThread::AddLog(UnicodeString msg, bool must_log)
{
	if (!LogErrOnly || must_log || USTARTS_TS("E ", msg) || USTARTS_TS("C ", msg)) {
		UnicodeString s;
		if (!msg.IsEmpty()) s.sprintf(_T("%u>%s"), Tag + 1, msg.c_str());
		LogRWLock->BeginWrite();
			LogBufStr.cat_sprintf(_T("%s\r\n"), s.c_str());
		LogRWLock->EndWrite();
	}
}

//---------------------------------------------------------------------------
//t@C\ɂȂ܂ő҂
// vr[Ǎ̏ꍇ
//---------------------------------------------------------------------------
bool __fastcall TTaskThread::WaitFileReady(UnicodeString fnam)
{
	int wait = 20;	//*** ő10b
	while (ImgViewThread && ImgViewThread->TaskBusy && SameText(fnam, ImgViewThread->FileName) && wait>0) {
		Sleep(500); wait--;
	}
	return (wait>0);
}

//---------------------------------------------------------------------------
//fBNg̃}XNɊYSt@C擾
//---------------------------------------------------------------------------
int __fastcall TTaskThread::GetFiles(
	UnicodeString pnam,		//fBNg
	UnicodeString mask,		//}XN
	TStrings *lst,			//ʂi[Xg
	bool empSW,				//̃TufBNg擾 (default = false)
	bool symSW)				//V{bNN	 (default = false)
{
	int fcnt = 0;
	if (!dir_exists(pnam) || (!symSW && is_SymLink(pnam))) return fcnt;

	pnam = IncludeTrailingPathDelimiter(pnam);
	set_if_empty(mask, _T("*.*"));

	//TufBNg
	UnicodeString sea_str;
	TSearchRec sr;
	sea_str = cv_ex_filename(UAPP_T(pnam, "*"));
	if (FindFirst(sea_str, faAnyFile, sr)==0) {
		do {
			if ((sr.Attr & faDirectory)==0) continue;
			UnicodeString dnam = sr.Name;
			if (ContainsStr("..", dnam)) continue;
			if (!symSW && is_SymLink(pnam + dnam)) continue;
			int scnt = GetFiles(pnam + dnam, mask, lst, empSW, symSW);
			fcnt += scnt;
			if (empSW && scnt==0) {
				//̃TufBNg
				lst->Add(IncludeTrailingPathDelimiter(pnam + dnam));
				PreCount = lst->Count;
			}
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
	}

	//t@C
	sea_str = cv_ex_filename(pnam + mask);
	if (FindFirst(sea_str, faAnyFile, sr)==0) {
		do {
			if (sr.Attr & faDirectory) continue;

			//^CX^vɂtB^O
			if (Config->FilterMode>0) {
				TValueRelationship res = System::Dateutils::CompareDate(sr.TimeStamp, Config->FilterTime);
				bool ok = false;
				switch (Config->FilterMode) {
				case 1: ok = (res==LessThanValue);		break;
				case 2: ok = (res==EqualsValue);		break;
				case 3: ok = (res==GreaterThanValue);	break;
				}
				if (!ok) continue;
			}

			lst->Add(pnam + sr.Name);
			fcnt++;
			PreCount = lst->Count;
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
	}

	return fcnt;
}
//---------------------------------------------------------------------------
//fBNg̃}XNɊYSt@C̃Xgǉ擾
//  ߂l: t@C(fBNg͏)
//---------------------------------------------------------------------------
int __fastcall TTaskThread::GetFilesEx(
	UnicodeString pnam,			//fBNg
	UnicodeString inc_mask,		//Ώۃ}XN(;ŋ؂蕡w)
	UnicodeString exc_mask,		//O}XN(;ŋ؂蕡w)
	TStrings *lst,				//ʂi[ TStrings
	bool subSW,					//TufBNg				(default = fals)
	UnicodeString skip_dir,		//OfBNg(;ŋ؂蕡w)	(default = EmptyStr)
	TStringList *d_lst,			//TufBNg̃Xg				(default = NUL)
	bool symSW,					//V{bNN		 		(default = false)
	bool dateSW)				//t𗘗p						(default = false)
{
	int fcnt = 0;
	if (!dir_exists(pnam) || (!symSW && is_SymLink(pnam))) return fcnt;

	pnam = IncludeTrailingPathDelimiter(pnam);

	//OfBNg
	TStringDynArray skip_dir_lst = split_strings_semicolon(skip_dir);
	//}XN
	set_if_empty(inc_mask, _T("*"));
	TStringDynArray inc_msk_lst = split_strings_semicolon(inc_mask);	//Ώ
	TStringDynArray exc_msk_lst = split_strings_semicolon(exc_mask);	//O

	TSearchRec sr;
	if (FindFirst(cv_ex_filename(UAPP_T(pnam, "*")), faAnyFile, sr)==0) {
		do {
			//TufBNg
			if (subSW && (sr.Attr & faDirectory)) {
				UnicodeString dnam = sr.Name;
				if (ContainsStr("..", dnam)) continue;
				if (!symSW && is_SymLink(pnam + dnam)) continue;

				if (d_lst) d_lst->Add(pnam + dnam);

				//OfBNg̃`FbN
				bool skip = false;
				for (int i=0; i<skip_dir_lst.Length; i++) {
					if (skip_dir_lst[i].IsEmpty()) continue;
					if (str_match(skip_dir_lst[i], dnam)) {
						skip = true; break;
					}
				}

				if (!skip) fcnt += GetFilesEx(pnam + dnam, inc_mask, exc_mask, lst, subSW, skip_dir, d_lst, symSW, dateSW);
			}
			//t@C
			else {
				//Ώۃ`FbN
				bool ok = false;
				for (int i=0; i<inc_msk_lst.Length; i++) {
					if (inc_msk_lst[i].IsEmpty()) continue;
					if (str_match(inc_msk_lst[i], sr.Name)) {
						ok = true; break;
					}
				}
				if (!ok) continue;
				//O`FbN
				for (int i=0; i<exc_msk_lst.Length; i++) {
					if (exc_msk_lst[i].IsEmpty()) continue;
					if (str_match(exc_msk_lst[i], sr.Name)) {
						ok = false; break;
					}
				}
				if (!ok) continue;
	
				//^CX^vɂtB^O
				if (dateSW && Config->FilterMode>0) {
					TValueRelationship res = System::Dateutils::CompareDate(sr.TimeStamp, Config->FilterTime);
					ok = false;
					switch (Config->FilterMode) {
					case 1: ok = (res==LessThanValue);		break;
					case 2: ok = (res==EqualsValue);		break;
					case 3: ok = (res==GreaterThanValue);	break;
					}
					if (!ok) continue;
				}

				lst->Add(pnam + sr.Name); fcnt++;
				PreCount = lst->Count;
			}
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
	}

	return fcnt;
}

//---------------------------------------------------------------------------
//fBNg̑SfBNg擾
//---------------------------------------------------------------------------
void __fastcall TTaskThread::GetDirs(UnicodeString pnam, TStrings *lst)
{
	if (pnam.IsEmpty() || !dir_exists(pnam)) return;

	pnam = IncludeTrailingPathDelimiter(pnam);
	UnicodeString sea_str = cv_ex_filename(UAPP_T(pnam, "*"));
	TSearchRec sr;
	if (FindFirst(sea_str, faAnyFile, sr)==0) {
		do {
			if ((sr.Attr & faDirectory)==0) continue;
			UnicodeString dnam = sr.Name;
			if (ContainsStr("..", dnam)) continue;
			lst->Add(pnam + dnam);
			PreCount = lst->Count;
			GetDirs(pnam + dnam, lst);
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
	}
}

//---------------------------------------------------------------------------
//t@C̃Rs[/ړ
//---------------------------------------------------------------------------
void __fastcall TTaskThread::CPY_core(
	UnicodeString fnam, 		//Rs[
	UnicodeString dst_path,		//Rs[
	bool mov_sw,				//true = ړ/ false = Rs[
	bool remove_ro,				//true = Ǎp
	TStringList *skip_list)		//XLbvfBNg̃Xg (default = NULL)
{
	UnicodeString msg;

	//Rs[悪Ȃ΍쐬
	if (!dir_exists(dst_path)) {
		msg = make_LogHdr(_T("CREATE"), dst_path, true);
		GetLastError();
		if (create_ForceDirs(dst_path)) dir_CopyAttr(ExtractFileDir(fnam), dst_path, remove_ro); else set_LogErrMsg(msg);
		AddLog(msg);
	}

	if (ends_PathDlmtr(fnam)) return;

	msg = make_LogHdr(mov_sw? _T("MOVE") : _T("COPY"), fnam);
	CurFileName = fnam;
	CopyName	= ExtractFileName(fnam);
	CurProgress = -1;

	UnicodeString dst_fnam = dst_path + CopyName;

	//fBNg
	if (dir_exists(dst_fnam)) {
		ErrCount++;
		set_LogErrMsg(msg, LoadUsrMsg(USTR_NgSameName));
		AddLog(msg);
		CurFileName  = EmptyStr;
		CurTotalSize = 0;
		return;
	}

	//
	if (!Config->CopyAll && file_exists(dst_fnam)) {
		CurSrcName  = fnam;
		CurDstName	= dst_fnam;
		IsSamePath	= SameText(ExtractFilePath(fnam), dst_path);
		TaskAskSame = true;
		while (TaskAskSame && !TaskCancel) Sleep(250);
	}
	//f
	if (TaskCancel) {
		msg[1] = 'C';
		AddLog(msg);
		return;
	}

	bool w_flag = true;
	if (file_exists(dst_fnam)) {
		bool skiped = false;

		//㏑
		if (Config->CopyMode==0)
			msg[1] = 'O';
		//ŐVȂ
		else if (Config->CopyMode==1) {
			if (is_NewerTime(get_file_age(fnam), get_file_age(dst_fnam)))
				msg[1] = 'N';
			else {
				w_flag = false;
				SkipCount++;
				if (LogHideSkip) msg = EmptyStr; else msg[1] = 'S';
				skiped = true;
			}
		}
		//XLbv
		else if (Config->CopyMode==2) {
			w_flag = false;
			SkipCount++;
			if (LogHideSkip) msg = EmptyStr; else msg[1] = 'S';
			skiped = true;
		}
		//IɖOύX
		else if (Config->CopyMode==3) {
			dst_fnam = format_CloneName(Config->CopyFmt, fnam, dst_path, false);
			set_RenameLog(msg, dst_fnam);
		}
		//OύX
		else if (Config->CopyMode==4) {
			dst_fnam = dst_path + CopyName;
			if (!file_exists(dst_fnam)) {
				set_RenameLog(msg, CopyName);
			}
			else {
				w_flag = false;
				ErrCount++;
				set_LogErrMsg(msg, LoadUsrMsg(USTR_DuplicateName));
			}
		}
		//ŐVȂobNAbv
		else if (Config->CopyMode==10) {
			if (is_NewerTime(get_file_age(fnam), get_file_age(dst_fnam)))
				msg[1] = 'N';
			else {
				w_flag = false;
				SkipCount++;
				msg = EmptyStr;
			}
		}

		if (skiped && skip_list) {
			UnicodeString dnam = ExtractFilePath(fnam);
			if (skip_list->IndexOf(dnam)==-1) skip_list->Add(dnam);
		}
	}

	if (Config->SetDstPos && SetDstName.IsEmpty()) SetDstName = dst_fnam;

	//㏑()s
	if (w_flag) {
		try {
			GetLastError();
			if (ForceDel && !set_FileWritable(dst_fnam)) throw Exception(EmptyStr);

			LastTransferred.QuadPart = 0;
			SmplSize  = 0;
			LastCount = 0;
			Speed	  = 0;

			//ړ
			if (mov_sw) {
				if (!WaitFileReady(fnam))		throw Exception(EmptyStr);
				if (SameText(fnam, dst_fnam))	throw Exception(EmptyStr);
				if (!::MoveFileWithProgress(cv_ex_filename(fnam).c_str(), cv_ex_filename(dst_fnam).c_str(),
					ProgressRoutine, (LPVOID)this,
					MOVEFILE_REPLACE_EXISTING|MOVEFILE_COPY_ALLOWED|MOVEFILE_WRITE_THROUGH))
				{
					if (TaskCancel) Abort(); else throw Exception(EmptyStr);
				}
			}
			//Rs[
			else {
				BOOL  cancel  = FALSE;	//_~[ (f TaskCancel )

				//RAMfBXNƂ̊Ԃŏȃt@CRs[ƃG[ɂȂ錻ۂւ̑΍
				//  10MBȉ̏ꍇ COPY_FILE_NO_BUFFERING gȂ
				DWORD cpyflag = (CopyNoBuffering && get_file_size(fnam)>10485760)? COPY_FILE_NO_BUFFERING : 0;

				if (!::CopyFileEx(cv_ex_filename(fnam).c_str(), cv_ex_filename(dst_fnam).c_str(),
					ProgressRoutine, (LPVOID)this, (LPBOOL)&cancel, cpyflag))
				{
					if (TaskCancel) Abort(); else throw Exception(EmptyStr);
				}

				//CD-ROM̏ꍇAǍp
				if (remove_ro) {
					int attr = file_GetAttr(dst_fnam);	if (attr==faInvalid) throw Exception(EmptyStr);
					if (!file_SetAttr(dst_fnam, attr & ~faReadOnly)) throw Exception(EmptyStr);
				}
			}
			OkCount++;
		}
		catch (EAbort &e) {
			msg[1] = 'C';  msg += get_LogErrMsg();
		}
		catch (...) {
			ErrCount++;
			set_LogErrMsg(msg);
		}
	}

	if (!msg.IsEmpty()) AddLog(msg);

	CurProgress  = -1;
	CurFileName  = EmptyStr;
	CurTotalSize = 0;
}
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_CPY(UnicodeString prm,
	bool mov_sw)	//true = ړ/ false = Rs[
{
	UnicodeString src_prm  = split_pre_tab(prm);
	UnicodeString dst_path = prm;
	UnicodeString msg;

	if (src_prm.IsEmpty() || dst_path.IsEmpty()) return;

	UINT src_drv_typ = get_drive_type(src_prm);
	UINT dst_drv_typ = get_drive_type(dst_path);
	bool remove_ro	 = RemoveCdReadOnly && (src_drv_typ==DRIVE_CDROM);
	IsRemote		 = (src_drv_typ==DRIVE_REMOTE || dst_drv_typ==DRIVE_REMOTE);

	//t@C
	if (!ExtractFileName(src_prm).IsEmpty()) {
		//^CX^vɂtB^O
		if (Config->FilterMode>0) {
			bool ok = false;
			TValueRelationship res = System::Dateutils::CompareDate(get_file_age(src_prm), Config->FilterTime);
			switch (Config->FilterMode) {
			case 1:  ok = (res==LessThanValue);		break;
			case 2:  ok = (res==EqualsValue);		break;
			case 3:  ok = (res==GreaterThanValue);	break;
			}
			if (!ok) return;
		}

		CPY_core(src_prm, dst_path, mov_sw, remove_ro);
	}
	//fBNg
	else {
		bool is_same_drv = SameText(get_root_name(src_prm), get_root_name(dst_path));
		UnicodeString src_nam = ExcludeTrailingPathDelimiter(src_prm);
		UnicodeString dst_nam = dst_path + ExtractFileName(src_nam);

		//t@C
		if (file_exists_x(dst_nam)) {
			ErrCount++;
			msg = make_LogHdr(_T("MOVE"), src_nam);
			set_LogErrMsg(msg, LoadUsrMsg(USTR_NgSameName));
			AddLog(msg);
			return;
		}

		if (Config->SetDstPos && SetDstName.IsEmpty()) SetDstName = dst_nam;

		//hCuł̈ړ
		if (mov_sw && is_same_drv && !dir_exists(dst_nam)) {
			msg = make_LogHdr(_T("MOVE"), src_nam);
			try {
				GetLastError();
				if (!move_File(src_nam, dst_nam)) throw Exception(EmptyStr);
				OkCount++;
			}
			catch (...) {
				ErrCount++;
				set_LogErrMsg(msg);
			}
			AddLog(msg);
		}
		//Rs[擾
		else {
			UnicodeString org_path = get_parent_path(src_prm);
			std::unique_ptr<TStringList> fbuf(new TStringList());
			PreCount = 0;
			GetFiles(src_prm, "*.*", fbuf.get(), true, true);
			PreCount = 0;
			std::unique_ptr<TStringList> skip_lst(new TStringList());

			//Rs[
			if (fbuf->Count>0) {
				fbuf->Sort();
				for (int i=0; i<fbuf->Count && !TaskCancel; i++) {
					SubCount = fbuf->Count - i;
					UnicodeString fnam = fbuf->Strings[i];
					UnicodeString sub_path = fnam;
					sub_path.Delete(1, org_path.Length());
					sub_path = ExtractFilePath(sub_path);
					CPY_core(fnam, dst_path + sub_path, mov_sw, remove_ro, skip_lst.get());
					Sleep(MIN_INTERVAL);
				}
			}
			//fBNg
			else if (!dir_exists(dst_nam)) {
				msg = make_LogHdr(_T("CREATE"), dst_nam, true);
				GetLastError();
				if (create_ForceDirs(dst_nam)) dir_CopyAttr(src_prm, dst_nam, remove_ro); else set_LogErrMsg(msg);
				AddLog(msg);
			}

			//fBNg폜
			if (!TaskCancel && mov_sw) DEL_dirs(src_prm, skip_lst.get());
		}
	}
}

//---------------------------------------------------------------------------
//fBNg폜
//---------------------------------------------------------------------------
void __fastcall TTaskThread::DEL_dirs(
	UnicodeString pnam,			//폜fBNg
	TStringList *skip_list)		//XLbvfBNg̃Xg (default = NULL)
{
	if (pnam.IsEmpty()) return;
	pnam = to_path_name(pnam);
	bool is_sym = is_SymLink(pnam);

	//TufBNgč폜
	if (!is_sym) {
		UnicodeString sea_str = cv_ex_filename(UAPP_T(pnam, "*"));
		TSearchRec sr;
		if (FindFirst(sea_str, faAnyFile, sr)==0) {
			do {
				if ((sr.Attr & faDirectory)==0 || ContainsStr("..", sr.Name)) continue;
				DEL_dirs(pnam + sr.Name, skip_list);
			} while(FindNext(sr)==0);
			FindClose(sr);

			Sleep(MIN_INTERVAL);
		}
	}

	//fBNg폜
	UnicodeString msg = make_LogHdr(is_sym? _T("REMOVE") : _T("DELETE"), pnam, true);

	try {
		bool skiped = false;
		if (skip_list) {
			for (int i=0; i<skip_list->Count && !skiped; i++)
				skiped = StartsText(pnam, skip_list->Strings[i]);
		}

		if (skiped) {
			if (LogHideSkip) msg = EmptyStr; else msg[1] = 'S';
		}
		else {
			GetLastError();
			if (!dir_exists(pnam))	Abort();
			if (ForceDel && !set_FileWritable(pnam)) Abort();
			if (!delete_Dir(pnam))	Abort();
			DirDeleted = true;
		}
	}
	catch (EAbort &e) {
		ErrCount++;
		set_LogErrMsg(msg);
	}

	if (!msg.IsEmpty()) AddLog(msg);
}

//---------------------------------------------------------------------------
//t@C폜
//---------------------------------------------------------------------------
void __fastcall TTaskThread::DEL_core(UnicodeString fnam)
{
	CurFileName = fnam;
	UnicodeString msg = make_LogHdr(_T("DELETE"), fnam);

	try {
		GetLastError();
		if (!file_exists(fnam))					 Abort();
		if (!WaitFileReady(fnam))				 Abort();
		if (ForceDel && !set_FileWritable(fnam)) Abort();
		if (!delete_File(fnam, DelUseTrash))	 Abort();
		del_CachedIcon(fnam);
		OkCount++;
	}
	catch (EAbort &e) {
		ErrCount++;
		set_LogErrMsg(msg);
	}

	AddLog(msg);
	CurFileName = EmptyStr;
}
//---------------------------------------------------------------------------
//ݔɂfBNg폜
//---------------------------------------------------------------------------
void __fastcall TTaskThread::DEL_dir_trash(UnicodeString dnam)
{
	UnicodeString msg = make_LogHdr(_T("DELETE"), dnam, true);
	try {
		GetLastError();
		if (!dir_exists(dnam))						Abort();
		if (ForceDel && !set_FileWritable(dnam))	Abort();
		if (!delete_File(ExcludeTrailingPathDelimiter(dnam), true))	Abort();
		OkCount++;
	}
	catch (EAbort &e) {
		ErrCount++;
		set_LogErrMsg(msg);
	}
	AddLog(msg);
}
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_DEL(UnicodeString prm)
{
	if (prm.IsEmpty()) return;

	//t@C
	if (!ExtractFileName(prm).IsEmpty())
		DEL_core(prm);
	//fBNg( \)
	else if (dir_exists(prm)) {
		//ݔ
		if (DelUseTrash)
			DEL_dir_trash(prm);
		else {
			//V{bNNAWNV
			if (is_SymLink(prm))
				DEL_dirs(prm);
			//ʏ
			else {
				//fBNg̍폜
				std::unique_ptr<TStringList> fbuf(new TStringList());
				PreCount = 0;
				GetFiles(prm, "*.*", fbuf.get());
				PreCount = 0;
				for (int i=0; i<fbuf->Count && !TaskCancel; i++) {
					while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);
					SubCount = fbuf->Count - i;
					DEL_core(fbuf->Strings[i]);
					if (ReqTaskSlow) {
						ReqTaskSlow = false;
						Sleep(SLOW_INTERVAL);
					}
					else if (i%32==0)
						Sleep(MIN_INTERVAL);
				}

				Sleep(MIN_INTERVAL);

				if (!TaskCancel) DEL_dirs(prm);
			}
		}
	}
}

//---------------------------------------------------------------------------
//t@CS폜
//---------------------------------------------------------------------------
void __fastcall TTaskThread::CMPDEL_core(UnicodeString fnam)
{
	CurFileName = fnam;
	UnicodeString msg = make_LogHdr(_T("CMPDEL"), fnam);
	try {
		GetLastError();
		if (!file_exists(fnam))		 throw Exception(EmptyStr);
		if (!WaitFileReady(fnam))	 throw Exception(EmptyStr);
		if (!set_FileWritable(fnam)) throw Exception(EmptyStr);

		Randomize();
		std::unique_ptr<char[]> wbuf(new char[CMPDEL_BUFF_SIZE]);

		if      (CmpDelOwCnt<=0) CmpDelOwCnt = 3;
		else if (CmpDelOwCnt>50) CmpDelOwCnt = 50;

		__int64 f_size	   = get_file_size(fnam);
		__int64 total_sz   = f_size * CmpDelOwCnt;
		__int64 written_sz = 0;
		int wcnt = f_size / CMPDEL_BUFF_SIZE;
		int rcnt = f_size % CMPDEL_BUFF_SIZE;
		CurProgress = -1;

		UnicodeString l_fnam = cv_ex_filename(fnam);
		HANDLE hFile = ::CreateFile(l_fnam.c_str(),
			GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile==INVALID_HANDLE_VALUE) throw Exception(EmptyStr);

		try {
			for (int i=0; i<CmpDelOwCnt; i++) {
				//_p^[쐬
				for (int j=0; j<CMPDEL_BUFF_SIZE; j++) wbuf[j] = Random(256);
				//擪փV[N
				::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
				//
				DWORD wbyt;
				for (int j=0; j<wcnt; j++) {
					while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);

					if (ReqTaskSlow) {
						ReqTaskSlow = false;
						Sleep(SLOW_INTERVAL);
					}
					else if (j%128==0)
						Sleep(MIN_INTERVAL);

					if (TaskCancel) throw Exception(EmptyStr);	//f
					if (!WriteFile(hFile, wbuf.get(), CMPDEL_BUFF_SIZE, &wbyt, NULL)) throw Exception(EmptyStr);
					written_sz += wbyt;
					CurProgress = 1.0*written_sz/total_sz;
					if (Random(8)==0)
						for (int k=0; k<CMPDEL_BUFF_SIZE; k++) wbuf[k] = Random(256);	//Ƃǂp^[ύX
				}
				//[oCg
				if (rcnt>0) {
					if (!WriteFile(hFile, wbuf.get(), rcnt, &wbyt, NULL)) throw Exception(EmptyStr);
					written_sz += wbyt;
					CurProgress = 1.0*written_sz/total_sz;
				}
			}
			//TCY0ɐ؂l߂
			::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
			::SetEndOfFile(hFile);
			::CloseHandle(hFile);
		}
		catch (...) {
			::CloseHandle(hFile);
			if (TaskCancel) Abort();
		}

		//폜
		if (!delete_File(fnam)) throw Exception(EmptyStr);
		del_CachedIcon(fnam);

		OkCount++;
	}
	catch (EAbort &e) {
		msg[1] = 'C';  msg.UCAT_T("\r\n    v͒f܂B");
	}
	catch (...) {
		ErrCount++;
		set_LogErrMsg(msg);
	}

	AddLog(msg);
	CurFileName = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_CMPDEL(UnicodeString prm)
{
	if (!ExtractFileName(prm).IsEmpty())
		CMPDEL_core(prm);
	else if (dir_exists(prm)) {
		if (!is_SymLink(prm)) {
			//fBNg̍폜
			std::unique_ptr<TStringList> fbuf(new TStringList());
			PreCount = 0;
			GetFiles(prm, "*.*", fbuf.get());
			PreCount = 0;
			for (int i=0; i<fbuf->Count && !TaskCancel; i++) {
				SubCount = fbuf->Count - i;
				CMPDEL_core(fbuf->Strings[i]);
				Sleep(MIN_INTERVAL);
			}
		}
		if (!TaskCancel) DEL_dirs(prm);
	}
}

//---------------------------------------------------------------------------
//fBNg\̃Rs[
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_CPYDIR(UnicodeString prm)
{
	UnicodeString src_prm  = split_pre_tab(prm);
	UnicodeString dst_path = prm;
	if (src_prm.IsEmpty() || dst_path.IsEmpty()) return;

	bool remove_ro = RemoveCdReadOnly && (get_drive_type(src_prm)==DRIVE_CDROM);

	//擾
	std::unique_ptr<TStringList> dbuf(new TStringList());
	dbuf->Add(src_prm);
	PreCount = 1;
	GetDirs(src_prm, dbuf.get());
	PreCount = 0;

	//Rs[(쐬)
	UnicodeString org_path = get_parent_path(src_prm);
	for (int i=0; i<dbuf->Count && !TaskCancel; i++) {
		SubCount = dbuf->Count - i;
		UnicodeString dnam = dbuf->Strings[i];
		UnicodeString sub_path = dnam;
		sub_path.Delete(1, org_path.Length());
		UnicodeString dst_nam = dst_path + sub_path;
		UnicodeString msg = make_LogHdr(_T("CREATE"), dst_nam, true);
		if (!dir_exists(dst_nam)) {
			GetLastError();
			if (create_ForceDirs(dst_nam)) {
				//
				dir_CopyAttr(dnam, dst_nam, remove_ro);
				//^CX^v
				if (Config->KeepTime) {
					TDateTime ft = get_file_age(dnam);
					if ((int)ft>0) set_file_age(dst_nam, ft);
				}
				OkCount++;
			}
			else {
				ErrCount++;
				set_LogErrMsg(msg);
			}
		}
		else {
			SkipCount++;
			if (LogHideSkip) msg = EmptyStr; else msg[1] = 'S';
		}

		if (!msg.IsEmpty()) AddLog(msg);
	}
}

//---------------------------------------------------------------------------
//摜t@C̕ϊ
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_CVIMG(UnicodeString prm)
{
	UnicodeString fnam	   = split_pre_tab(prm);
	UnicodeString dst_path = prm;

	CurFileName = fnam;
	bool is_wmf = test_MetaExt(ExtractFileExt(fnam));

	UnicodeString msg  = make_LogHdr(_T("CVIMG"), fnam);

	try {
		if (!file_exists(fnam)) throw Exception(EmptyStr);

		//OɃ^CX^vĂ
		TDateTime ft;
		if (Config->KeepTime) ft = get_file_age(fnam);

		//ǂݍ
		std::unique_ptr<Graphics::TBitmap> i_img(new Graphics::TBitmap());
		std::unique_ptr<TMetafile> mf(new TMetafile());
		unsigned int i_wd, i_hi;
		//^t@C
		if (is_wmf) {
			mf->LoadFromFile(fnam);
			i_wd = mf->Width;
			i_hi = mf->Height;
		}
		//摜t@C
		else {
			TColor bg = test_FileExt(ExtractFileExt(fnam), _T(".png.gif"))? Config->CvImg_mgn_color : clNone;
			if (load_ImageFile(fnam, i_img.get(), (Config->CvImg_not_use_prvw? WICIMG_FRAME : WICIMG_PREVIEW), bg)==0)
				UserAbort(USTR_FaildLoad);
			i_wd = i_img->Width;
			i_hi = i_img->Height;
		}
		if (i_wd==0 || i_hi==0) TextAbort(_T("摜̃TCYsł"));

		//kEg
		if (Config->CvImg_scale_mode>0) {
			float r, r0, r1;
			std::unique_ptr<Graphics::TBitmap> r_img(new Graphics::TBitmap());

			//p[^`FbN
			switch (Config->CvImg_scale_mode) {
			case 1:
				if (Config->CvImg_scale_prm1==0) UserAbort(USTR_IllegalParam);
				break;
			case 5: case 6: case 7: case 8:
				if (Config->CvImg_scale_prm1==0 || Config->CvImg_scale_prm2==0) UserAbort(USTR_IllegalParam);
				break;
			default:
				if (Config->CvImg_scale_prm1==0) UserAbort(USTR_IllegalParam);
			}

			//ύXTCY߂
			switch (Config->CvImg_scale_mode) {
			case 2:	//c̒
				if (i_wd>i_hi) {	//̕
					r = 1.0 * i_hi / i_wd;
					i_wd = Config->CvImg_scale_prm1;
					i_hi = i_wd * r;
				}
				else {			//c̕
					r = 1.0 * i_wd / i_hi;
					i_hi = Config->CvImg_scale_prm1;
					i_wd = i_hi * r;
				}
				break;
			case 3:	//TCYw
				r = 1.0 * i_hi / i_wd;
				i_wd = Config->CvImg_scale_prm1;
				i_hi = i_wd * r;
				break;
			case 4:	//cTCYw
				r = 1.0 * i_wd / i_hi;
				i_hi = Config->CvImg_scale_prm1;
				i_wd = i_hi * r;
				break;
			case 5: case 7: //wTCYɎ߂/ ]t
				r0 = 1.0 * i_wd / i_hi;
				r1 = 1.0 * Config->CvImg_scale_prm1 / Config->CvImg_scale_prm2;
				if (r0>r1) {
					r = 1.0 * i_hi / i_wd;
					i_wd = Config->CvImg_scale_prm1;
					i_hi = i_wd * r;
				}
				else {
					r = 1.0 * i_wd / i_hi;
					i_hi = Config->CvImg_scale_prm2;
					i_wd = i_hi * r;
				}
				break;
			case 6:	//wTCYɃXgb`
				i_wd = Config->CvImg_scale_prm1;
				i_hi = Config->CvImg_scale_prm2;
				break;
			case 8:	//wTCYɍ킹Đ؂o
				r0 = 1.0 * i_wd / i_hi;
				r1 = 1.0 * Config->CvImg_scale_prm1 / Config->CvImg_scale_prm2;
				if (r0<r1) {
					r = 1.0 * i_hi / i_wd;
					i_wd = Config->CvImg_scale_prm1;
					i_hi = i_wd * r;
				}
				else {
					r = 1.0 * i_wd / i_hi;
					i_hi = Config->CvImg_scale_prm2;
					i_wd = i_hi * r;
				}
				break;
			}

			//kEg
			//^t@C
			if (is_wmf) {
				if (Config->CvImg_scale_mode==1) {
					//{w
					float r = Config->CvImg_scale_prm1/100.0;
					r_img->SetSize(i_wd * r, i_hi * r);
				}
				else {
					//cETCYw
					r_img->SetSize(i_wd, i_hi);
				}
				TRect rc = Rect(0, 0, r_img->Width, r_img->Height);
				r_img->Canvas->Brush->Color = Config->CvImg_mgn_color;
				r_img->Canvas->FillRect(rc);
				r_img->Canvas->StretchDraw(rc, mf.get());
			}
			//摜t@C
			else {
				//Ԃ
				if (Config->CvImg_scale_opt>=0 && Config->CvImg_scale_opt<=3) {
					//{w
					if (Config->CvImg_scale_mode==1) {
						if (!WIC_resize_image(i_img.get(), r_img.get(),
							Config->CvImg_scale_prm1/100.0, 0, 0, Config->CvImg_scale_opt))
								UserAbort(USTR_FaildProc);
					}
					//cETCYw
					else {
						if (!WIC_resize_image(i_img.get(), r_img.get(), 0.0, i_wd, i_hi, Config->CvImg_scale_opt))
							UserAbort(USTR_FaildProc);
					}
				}
				//ԂȂ
				else {
					int r_wd = i_wd;
					int r_hi = i_hi;
					if (Config->CvImg_scale_mode==1) {
						float r = Config->CvImg_scale_prm1/100.0;
						r_wd = i_wd * r;
						r_hi = i_hi * r;
					}
					r_img->SetSize(r_wd, r_hi);
					r_img->PixelFormat = pf24bit;
					r_img->Canvas->StretchDraw(Rect(0, 0, r_wd, r_hi), i_img.get());
				}
			}

			//ʂ蓖Ă
			int xp, yp;
			switch (Config->CvImg_scale_mode) {
			case 7:	//]t
				xp = (Config->CvImg_scale_prm1 - i_wd)/2;
				yp = (Config->CvImg_scale_prm2 - i_hi)/2;
				i_img->SetSize(Config->CvImg_scale_prm1, Config->CvImg_scale_prm2);
				i_img->Canvas->Brush->Color = Config->CvImg_mgn_color;
				i_img->Canvas->FillRect(Rect(0, 0, Config->CvImg_scale_prm1, Config->CvImg_scale_prm2));
				i_img->Canvas->Draw(xp, yp, r_img.get());
				break;
			case 8:	//؂o
				xp = (i_wd - Config->CvImg_scale_prm1)/2;
				yp = (i_hi - Config->CvImg_scale_prm2)/2;
				i_img->SetSize(Config->CvImg_scale_prm1, Config->CvImg_scale_prm2);
				i_img->Canvas->CopyRect(Rect(0, 0, Config->CvImg_scale_prm1, Config->CvImg_scale_prm2),
					r_img->Canvas, Rect(xp, yp, xp + Config->CvImg_scale_prm1, yp + Config->CvImg_scale_prm2));
				break;
			default:
				i_img->Handle = r_img->ReleaseHandle();
			}
		}

		//O[XP[
		if (Config->CvImg_grayscale) WIC_grayscale_image(i_img.get());

		//t@C̕ύX
		UnicodeString bnam = get_base_name(fnam);
		if (!Config->CvImg_chg_name_str.IsEmpty()) {
			switch (Config->CvImg_chg_name_mode) {
			case 0: bnam  = Config->CvImg_chg_name_str + bnam;	break;
			case 1: bnam += Config->CvImg_chg_name_str;			break;
			}
		}
		UnicodeString cv_nam = dst_path + bnam + Config->CvImg_f_ext;
		msg.cat_sprintf(_T(" ---> %s"), ExtractFileName(cv_nam).c_str());

		//`ϊĕۑ
		if (!WIC_save_image(cv_nam, i_img.get(),
			Config->CvImg_quality, Config->CvImg_ycrcb, Config->CvImg_grayscale, Config->CvImg_cmp_mode))
				UserAbort(USTR_FaildSave);

		//^CX^vݒ
		if (Config->KeepTime && (int)ft>0) set_file_age(cv_nam, ft);

		OkCount++;
	}
	catch (EAbort &e) {
		ErrCount++;
		set_LogErrMsg(msg, e.Message);
	}
	catch (...) {
		ErrCount++;
		msg[1] = 'E';
	}

	AddLog(msg);
	CurFileName = EmptyStr;
}

//---------------------------------------------------------------------------
//Jpeg t@C Exif 폜
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_DLEXIF(UnicodeString prm)
{
	UnicodeString fnam = split_pre_tab(prm);
	UnicodeString onam = prm + ExtractFileName(fnam);

	CurFileName = fnam;
	UnicodeString msg = make_LogHdr(_T("DLEXIF"), fnam);

	try {
		int res = EXIF_DelJpgExif(fnam, onam, Config->KeepTime);
		if (res==-1) throw Exception(EmptyStr);
		if (res==1) {
			if (LogHideSkip) msg = EmptyStr; else msg[1] = 'S';
			SkipCount++;
		}
		else
			OkCount++;
	}
	catch (...) {
		ErrCount++;
		msg[1] = 'E';
	}

	if (!msg.IsEmpty()) AddLog(msg);
	CurFileName = EmptyStr;
}

//---------------------------------------------------------------------------
//HTMLwv(.chm)\[X𒊏o
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_EXTCHM(UnicodeString prm)
{
	UnicodeString fnam	= split_pre_tab(prm);
	CurFileName = fnam;
	UnicodeString o_dir = ExcludeTrailingPathDelimiter(prm);
	UnicodeString c_dir = ExtractFileDir(fnam);
	fnam = ExtractFileName(fnam);

	UnicodeString cmdln;
	cmdln.sprintf(_T("hh.exe -decompile %s %s"), o_dir.c_str(), fnam.c_str());
	AddLog("  EXECUTE " + cmdln);
	STARTUPINFO si;
	::ZeroMemory(&si, sizeof(si) );
	si.cb = sizeof(si);
	si.dwFlags	   = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_SHOWNORMAL;
	PROCESS_INFORMATION pi;
	if (::CreateProcess(NULL, cmdln.c_str(), NULL, NULL, TRUE, 0, NULL, c_dir.c_str(), &si, &pi)) {
		//I҂
		while (::WaitForSingleObject(pi.hProcess, 50)==WAIT_TIMEOUT) Sleep(MIN_INTERVAL);
		::CloseHandle(pi.hThread);
		::CloseHandle(pi.hProcess);
	}
	CurFileName = EmptyStr;
}

//---------------------------------------------------------------------------
//obNAbv
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_BACKUP(UnicodeString prm)
{
	UnicodeString src_path = split_pre_tab(prm);
	UnicodeString dst_path = prm;

	//Rs[擾
	std::unique_ptr<TStringList> src_lst(new TStringList());
	PreCount = 0;
	GetFilesEx(src_path, Config->Bakup_inc_mask, Config->Bakup_exc_mask, src_lst.get(),
				Config->Bakup_sub_sw, Config->Bakup_skip_dir, NULL, true, true);
	PreCount = 0;

	//Rs[
	if (src_lst->Count>0) {
		src_lst->Sort();
		for (int i=0; i<src_lst->Count && !TaskCancel; i++) {
			SubCount = src_lst->Count - i;
			UnicodeString fnam = src_lst->Strings[i];
			UnicodeString sub_path = fnam;
			sub_path.Delete(1, src_path.Length());
			sub_path = ExtractFilePath(sub_path);
			Task_CPY(fnam + "\t" + dst_path + sub_path);
		}
	}
	if (TaskCancel) return;
	AddLog("         Rs[I" + get_res_cnt_str(OkCount, ErrCount, SkipCount));
	SubCount = OkCount = SkipCount = ErrCount = 0;

	//~[O
	if (Config->Bakup_mirror) {
		UnicodeString msg;
		msg.sprintf(_T("         ~[OJn  %s"), dst_path.c_str());
		if (!dir_exists(src_path)) {
			set_LogErrMsg(msg, "obNAbv܂B");
			AddLog(msg);
			return;
		}
		AddLog(msg);

		//obNAbvɂȂt@C폜
		std::unique_ptr<TStringList> dst_lst(new TStringList());
		std::unique_ptr<TStringList> dir_lst(new TStringList());
		PreCount = 0;
		GetFilesEx(dst_path, "*.*", EmptyStr, dst_lst.get(), Config->Bakup_sub_sw, EmptyStr, dir_lst.get());
		PreCount = 0;
		for (int i=0; i<dst_lst->Count && !TaskCancel; i++) {
			SubCount = dst_lst->Count - i;
			UnicodeString fnam = dst_lst->Strings[i];
			if (!file_exists(src_path + get_tkn_r(fnam, dst_path))) Task_DEL(fnam);
		}

		//obNAbvɂȂfBNg폜
		if (Config->Bakup_sub_sw) {
			for (int i=0; i<dir_lst->Count && !TaskCancel; i++) {
				UnicodeString pnam = dir_lst->Strings[i];
				UnicodeString snam = get_tkn_r(pnam, dst_path);
				while (!snam.IsEmpty() && !dir_exists(src_path + snam) && dir_exists(pnam)) {
					Task_DEL(IncludeTrailingPathDelimiter(pnam));
					snam = get_parent_path(snam);
				}
			}
		}

		AddLog("         ~[OI" + get_res_cnt_str(OkCount, ErrCount, SkipCount));
		SubCount = OkCount = SkipCount = ErrCount = 0;
	}
}

//---------------------------------------------------------------------------
//fBNg̃^CX^vŐVt@Ĉ̂ɐݒ
//---------------------------------------------------------------------------
TDateTime __fastcall TTaskThread::SetDirTime(UnicodeString dnam)
{
	dnam = IncludeTrailingPathDelimiter(dnam);
	UnicodeString sea_str = UAPP_T(dnam, "*");
	if (sea_str.Length()>=MAX_PATH) sea_str.Insert("\\\\?\\", 1);

	TDateTime dt = 0.0;
	int i_cnt = 0;
	TSearchRec sr;
	if (FindFirst(sea_str, faAnyFile, sr)==0) {
		int cnt = 0;
		do {
			while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);
			if ((sr.Attr & faDirectory)==0) continue;
			if (ContainsStr("..", sr.Name)) continue;
			dt = std::max(dt, SetDirTime(dnam + sr.Name));
			if (++cnt%32==0) Sleep(MIN_INTERVAL);
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
		i_cnt += cnt;
	}

	//t@C
	if (!TaskCancel && FindFirst(sea_str, faAnyFile, sr)==0) {
		int cnt = 0;
		do {
			while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);
			if (sr.Attr & faDirectory) continue;
			dt = std::max(dt, sr.TimeStamp);
			if (++cnt%128==0) Sleep(MIN_INTERVAL);
		} while(FindNext(sr)==0 && !TaskCancel);
		FindClose(sr);
		i_cnt += cnt;
	}

	if (!TaskCancel) {
		CurFileName = ExcludeTrailingPathDelimiter(dnam);
		TDateTime o_dt = get_file_age(dnam);
		if (!WithinPastMilliSeconds(o_dt, dt, TimeTolerance) && i_cnt>0) {
			UnicodeString msg = make_LogHdr(_T("TIME"), dnam, true, 14);	//***
			msg.cat_sprintf(_T("  %s ---> %s"), format_DateTime(o_dt).c_str(), format_DateTime(dt).c_str());
			GetLastError();
			if (set_file_age(dnam, dt, ForceDel))
				OkCount++;
			else {
				ErrCount++;
				set_LogErrMsg(msg);
			}
			AddLog(msg);
		}
		else {
			if (i_cnt==0) dt = o_dt;
			SkipCount++;
		}
	}

	return dt;
}
//---------------------------------------------------------------------------
void __fastcall TTaskThread::Task_DIRTIME(UnicodeString prm)
{
	SetDirTime(prm);
	CurFileName = EmptyStr;
}

//---------------------------------------------------------------------------
//^XN̊Jn
//---------------------------------------------------------------------------
bool __fastcall TTaskThread::TaskStart()
{
	OkCount = SkipCount = ErrCount = 0;
	CurProgress = -1;
	TaskCancel	= TaskPause = false;
	TaskIsFast  = ReqTaskSlow = false;
	TaskReady	= true;
	StartCount	= GetTickCount();
	return true;
}

//---------------------------------------------------------------------------
//^XN̏I(f)
//---------------------------------------------------------------------------
void __fastcall TTaskThread::FinishTask()
{
	//O\
	float tcnt = (GetTickCount() - StartCount)/1000.0;
	UnicodeString msg = FormatDateTime("hh:nn:ss ", Now());
	msg.cat_sprintf(_T("%sI %5.1fb"), TaskCmdList->Values[CmdName].c_str(), tcnt);
	msg += get_res_cnt_str(OkCount, ErrCount, SkipCount);
	if (TaskCancel) {
		msg.cat_sprintf(_T("  CANCELED:%u"), Config->TaskList->Count + 1);
		Config->TaskList->Clear();
		XCMD_Aborted = true;
	}
	AddLog(msg, true);

	TaskTime	 = (int)(tcnt + 0.5);
	TaskReady	 = false;
	TaskFinished = true;
}

//---------------------------------------------------------------------------
void __fastcall TTaskThread::Execute()
{
	::CoInitialize(NULL);

	::timeBeginPeriod(MIN_INTERVAL);

	while (!Terminated) {
		try {
			if (!TaskFinished && TaskCancel)
				FinishTask();
			else if (TaskPause)
				while (TaskPause && !TaskCancel) Sleep(WAIT_INTERVAL);
			else if (TaskReady) {
				if (Config->TaskList->Count>0) {
					SubCount = 0;
					UnicodeString lbuf = Config->TaskList->Strings[0];
					CmdName = split_pre_tab(lbuf);
					UnicodeString prmstr = lbuf;
					if (!CmdName.IsEmpty() && !prmstr.IsEmpty()) {
						switch (idx_of_word_i(_T("CPY|MOV|DEL|CPYDIR|CMPDEL|CVIMG|DLEXIF|EXTCHM|BACKUP|DTIME"), CmdName)) {
						case 0: Task_CPY(prmstr);		break;
						case 1: Task_CPY(prmstr, true);	break;
						case 2: Task_DEL(prmstr);		break;
						case 3: Task_CPYDIR(prmstr);	break;
						case 4: Task_CMPDEL(prmstr);	break;
						case 5: Task_CVIMG(prmstr);		break;
						case 6: Task_DLEXIF(prmstr);	break;
						case 7: Task_EXTCHM(prmstr);	break;
						case 8: Task_BACKUP(prmstr);	break;
						case 9: Task_DIRTIME(prmstr);	break;
						}
					}
					Config->TaskList->Delete(0);
					SubCount = 0;
					if (Config->TaskList->Count>0) Sleep(MIN_INTERVAL);
				}
				else FinishTask();
			}
			else Sleep(WAIT_INTERVAL);
		}
		catch (...) {
			ErrCount++;
			AddLog("E OG[\r\n    " + SysErrorMessage(EVENT_E_INTERNALEXCEPTION));
			TaskCancel = true;
			FinishTask();
		}
	}

	::timeEndPeriod(MIN_INTERVAL);

	delete Config;

	::CoUninitialize();
}
//---------------------------------------------------------------------------
